/*
 * $Id: harada.c,v 1.1 1997-09-28 20:20:15+09 harada Exp $
 */
#include "othello.h"

static int harada_count(char *board, int s){
	int n, sp, e;
	sp =  
	  (board[(s - 9) % 64] == SPACE ? 1 : 0)
	+ (board[(s - 8) % 64] == SPACE ? 1 : 0)
	+ (board[(s - 7) % 64] == SPACE ? 1 : 0)
	+ (board[(s - 1) % 64] == SPACE ? 1 : 0)
	+ (board[(s + 1) % 64] == SPACE ? 1 : 0)
	+ (board[(s + 7) % 64] == SPACE ? 1 : 0)
	+ (board[(s + 8) % 64] == SPACE ? 1 : 0)
	+ (board[(s + 9) % 64] == SPACE ? 1 : 0)
	;
	n =  
	  (board[(s - 9) % 64] == MY_COLOR ? 1 : 0)
	+ (board[(s - 8) % 64] == MY_COLOR ? 1 : 0)
	+ (board[(s - 7) % 64] == MY_COLOR ? 2 : 0)
	+ (board[(s - 1) % 64] == MY_COLOR ? 1 : 0)
	+ (board[(s + 1) % 64] == MY_COLOR ? 1 : 0)
	+ (board[(s + 7) % 64] == MY_COLOR ? 2 : 0)
	+ (board[(s + 8) % 64] == MY_COLOR ? 1 : 0)
	+ (board[(s + 9) % 64] == MY_COLOR ? 1 : 0)
	;
    e = 
	  (board[(s - 9) % 64] == OP_COLOR ? -1 : 0)
	+ (board[(s - 8) % 64] == OP_COLOR ? 1 : 0)
	+ (board[(s - 7) % 64] == OP_COLOR ? -1 : 0)
	+ (board[(s - 1) % 64] == OP_COLOR ? 1 : 0)
	+ (board[(s + 1) % 64] == OP_COLOR ? 1 : 0)
	+ (board[(s + 7) % 64] == OP_COLOR ? -1 : 0)
	+ (board[(s + 8) % 64] == OP_COLOR ? 1 : 0)
	+ (board[(s + 9) % 64] == OP_COLOR ? -1 : 0)
	;
/*	printf("debug: n = %d, sp = %d, e = %d\n", n, sp, e); */
	return n + sp + e;
}

int harada(char *board, int status){
	int i, max_i, max, n, r;

	if(passp(status) || initp(status)) return 0;

	max = 1 << 31;	/* INT_MIN */
	max_i = -1;
	for(i = 0; i < 64; i++)
		if((r = Put(board, i, MY_COLOR, NOT_CHANGE)) > 0){
			n = r * harada_count(board, i);
			if(n > max){ max = n; max_i = i; }
		}

	return max_i;
}
