#include "othello.h"
#include <stdlib.h>
#include<stdio.h>

#define	CLRCHG(a)		(3-(a))


#define	W1		64
#define	W2		-3
#define	W3		 9
#define	W4		 9
#define	W5		 0
#define	W6		 4
#define	W7		 2
#define	W8		 1
#define	W9		 0
/*
#define	W1		64
#define	W2		-3
#define	W3		 9
#define	W4		 9
#define	W5		 0
#define	W6		 4
#define	W7		 2
#define	W8		 1
#define	W9		 0
*/

static const
int org_weight[ 64 ] = {
	W1,W2,W3,W4,W4,W3,W2,W1,
	W2,W5,W6,W7,W7,W6,W5,W2,
	W3,W6,W8,W9,W9,W8,W6,W3,
	W4,W7,W9, 0, 0,W9,W7,W4,
	W4,W7,W9, 0, 0,W9,W7,W4,
	W3,W6,W8,W9,W9,W8,W6,W3,
	W2,W5,W6,W7,W7,W6,W5,W2,
	W1,W2,W3,W4,W4,W3,W2,W1,
};

#define	st(x,y)			board[y*8+x]
#define	we(x,y)			weight[y*8+x]
#define	C1				13
#define	C2				12
#define C3                              7

static
void change_table( char* board, int weight[64] )
{
	if ( st(0,1) ) { we(0,2)-=C1; we(1,2)-=C2; }
	if ( st(1,0) ) { we(2,0)-=C1; we(2,1)-=C2; }
	if ( st(0,6) ) { we(0,5)-=C1; we(1,5)-=C2; }
	if ( st(6,0) ) { we(5,0)-=C1; we(5,1)-=C2; }
	if ( st(7,1) ) { we(7,2)-=C1; we(6,2)-=C2; }
	if ( st(1,7) ) { we(2,7)-=C1; we(2,6)-=C2; }
	if ( st(7,6) ) { we(7,5)-=C1; we(6,5)-=C2; }
	if ( st(6,7) ) { we(5,6)-=C1; we(5,6)-=C2; }
}

static
int space_count( char* board )
{
	int	i,j;

	CountDisks(board,&i,&j);
	return ( 64 - ( i + j ));
}

static
int test_next( char* board, int color, int* p_place, const int pass )
{
	char	bd[64];
	int		i, j, p, w, dummy;

	p = -1; w = 9999;
	for ( i = 0; i < 64; i++ ) {
		if ( ( j = Put(board, i, color, NOT_CHANGE )) > 0 ) {
			CopyBoard( board, bd, NORM );
			if ( Put( bd, i, color, CHANGE ) <= 0 ) abort();
			j -= test_next( bd, CLRCHG(color), &dummy, 0 );
			if ( w > j ) { w = j; p = i; }
		}
	}

	if ( p == -1 ) {
		if ( pass ) return 0;
		return -test_next( board, CLRCHG(color), &dummy, 1 );
	}

	*p_place = p;
	return w;
}

/* ĤμɤڤäưŬʰ֤֤ */
/* ۾˽ŤΤǺǸΤۤˤȤʤ */
static
int test_all( char* board )
{
	int	place = -1;

	test_next( board, MY_COLOR, &place, 0 );
	return place;
}

int takeshima(char *board, int status)
{
	int	i, j, p, w, space;
	int weight[ 64 ];

	if(passp(status) || initp(status)) return 0;

	space = space_count( board );
	if ( space < 10 ) return test_all( board );
	for ( i = 0; i < 64; i++ ) {
		weight[i] = org_weight[i];
	}
	change_table( board, weight );

	p = -1; w = 9999;
	for ( i = 0; i < 64; i++ ) {
		if ( ( j = Put(board, i, MY_COLOR, NOT_CHANGE )) > 0 ) {
			j += weight[i];
			if ( w > j ) { w = j; p = i; }
		}
	}
	return p;
}
